
/*
 * testpivotaje.c
 *
 * Copyright (C) 2016 - igor
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <alglin.h>
void main()
{	
	double sA[6]={8.,4.,2.,6.,3.,5.};
	double sB[6]={8.,4.,2.,6.,3.,5.};
	double X[6]={1.,2.,1.,2.,1.,2.};
	double Y[6];
	double x[3]={1.,1.,1.};
	double b[3];
	
	printf("Prueba de factorización: matriz completa\n");
	printf("****************************************\n");
	
	ldlsimmatrizfactsA(sA,3,3);
	printf("matriz simétrica factorizada completa\n");
	simmatrizatexto(stdout,sA,3,3,5);
	printf("y en octave\n");
	simmatrizatextooctave(stdout,sA,3,3,5);
	
	vectorldlLTsAv(b,sA,3,3,x);
	printf("LTx\n");
	vectoratexto(stdout,b,3,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,3,5);
	
	vectorldlDsAv(b,sA,3,3,b);
	printf("DLTx\n");
	vectoratexto(stdout,b,3,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,3,5);
	
	vectorldlLsAv(b,sA,3,3,b);
	printf("LDLTx\n");
	vectoratexto(stdout,b,3,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,3,5);
	
	printf("Prueba de resolución: matriz completa\n");
	printf("*************************************\n");
	
	vectorldlinvLsAv(b,sA,3,3,b);
	printf("invLx\n");
	vectoratexto(stdout,b,3,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,3,5);
	
	vectorldlinvDsAv(b,sA,3,3,b);
	printf("invDinvLx\n");
	vectoratexto(stdout,b,3,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,3,5);
	
	vectorldlinvLTsAv(b,sA,3,3,b);
	printf("invLTinvDinvLx\n");
	vectoratexto(stdout,b,3,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,3,5);
	
	printf("Prueba de factorización: submatriz 2x2\n");
	printf("****************************************\n");
	
	ldlsimmatrizfactsA(sB,2,3);
	printf("matriz simétrica factorizada completa\n");
	simmatrizatexto(stdout,sB,2,3,5);
	printf("y en octave\n");
	simmatrizatextooctave(stdout,sB,2,3,5);
	
	printf("Así queda la matriz simétrica completa\n");
	simmatrizatexto(stdout,sB,3,3,5);
	printf("y en octave\n");
	simmatrizatextooctave(stdout,sB,3,3,5);
	
	
	vectorldlLTsAv(b,sB,2,3,x);
	printf("LTx\n");
	vectoratexto(stdout,b,2,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,2,5);
	
	vectorldlDsAv(b,sB,2,3,b);
	printf("DLTx\n");
	vectoratexto(stdout,b,2,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,2,5);
	
	vectorldlLsAv(b,sB,2,3,b);
	printf("LDLTx\n");
	vectoratexto(stdout,b,2,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,2,5);
	
	printf("Prueba de resolución: submatriz2x2\n");
	printf("*************************************\n");
	
	vectorldlinvLsAv(b,sB,2,3,b);
	printf("invLx\n");
	vectoratexto(stdout,b,2,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,2,5);
	
	vectorldlinvDsAv(b,sB,2,3,b);
	printf("invDinvLx\n");
	vectoratexto(stdout,b,2,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,2,5);
	
	vectorldlinvLTsAv(b,sB,2,3,b);
	printf("invLTinvDinvLx\n");
	vectoratexto(stdout,b,2,5);
	printf("vector en octave\n");
	vectoratextooctave(stdout,b,2,5);
	
	
	printf("Prueba de productos: matrizcompleta con matriz\n");
	printf("***********************************************\n");
	
	matrizldlLTsAB(Y,2,sA,3,3,X,2,2);
	printf("LTX\n");
	matrizatexto(stdout,Y,3,2,2,5);
	
	matrizldlDsAB(Y,2,sA,3,3,Y,2,2);
	printf("DLTX\n");
	matrizatexto(stdout,Y,3,2,2,5);
	
	matrizldlLsAB(Y,2,sA,3,3,Y,2,2);
	printf("LDLTX\n");
	matrizatexto(stdout,Y,3,2,2,5);
	
	printf("Prueba de resolucion: matrizcompleta con matriz\n");
	printf("***********************************************\n");
	
	matrizldlinvLsAB(Y,2,sA,3,3,Y,2,2);
	printf("invLY\n");
	matrizatexto(stdout,Y,3,2,2,5);
	
	matrizldlinvDsAB(Y,2,sA,3,3,Y,2,2);
	printf("invDinvLY\n");
	matrizatexto(stdout,Y,3,2,2,5);
	
	matrizldlinvLTsAB(Y,2,sA,3,3,Y,2,2);
	printf("invLTinvDinvLX\n");
	matrizatexto(stdout,Y,3,2,2,5);
}